Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.stat.descriptive.moment
Class Kurtosis

    java.lang.Object
      org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic
          org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic
              org.apache.commons.math3.stat.descriptive.moment.Kurtosis

All Implemented Interfaces:
  Serializable, StorelessUnivariateStatistic, UnivariateStatistic, MathArrays.Function

    public class Kurtosis

extends AbstractStorelessUnivariateStatistic
implements Serializable

Computes the Kurtosis of the available values.

We use the following (unbiased) formula to define kurtosis:

kurtosis = { [n(n+1) / (n -1)(n - 2)(n-3)] sum[(x_i - mean)^4] / std^4 } - [3(n-1)^2 / (n-2)(n-3)]

where n is the number of values, mean is the `Mean` and std is the `StandardDeviation`

Note that this statistic is undefined for n < 4. `Double.Nan` is returned when there is not sufficient data to compute the statistic.

Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

Version:
  $Id: Kurtosis.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Serialized Form

Field Summary
`protected boolean` | `incMoment` Determines whether or not this statistic can be incremented or cleared.
`protected org.apache.commons.math3.stat.descriptive.moment.FourthMoment` | `moment` Fourth Moment on which this statistic is based

Constructor Summary
`Kurtosis()` Construct a Kurtosis
`Kurtosis(org.apache.commons.math3.stat.descriptive.moment.FourthMoment m4)` Construct a Kurtosis from an external moment
`Kurtosis(Kurtosis original)` Copy constructor, creates a new `Kurtosis` identical to the `original`

Method Summary
`void` | `clear()` Clears the internal state of the Statistic
`Kurtosis` | `copy()` Returns a copy of the statistic with the same internal state.
`static void` | `copy(Kurtosis source, Kurtosis dest)` Copies source to dest.
`double` | `evaluate(double[] values, int begin, int length)` Returns the kurtosis of the entries in the specified portion of the input array.
`long` | `getN()` Returns the number of values that have been added.
`double` | `getResult()` Returns the current value of the Statistic.
`void` | `increment(double d)` Updates the internal state of the statistic to reflect the addition of the new value.

Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic
`equals, evaluate, hashCode, incrementAll, incrementAll`

Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic
`evaluate, getData, getDataRef, setData, setData, test, test, test, test`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### moment

    protected org.apache.commons.math3.stat.descriptive.moment.FourthMoment moment

  Fourth Moment on which this statistic is based

### incMoment

    protected boolean incMoment

  Determines whether or not this statistic can be incremented or cleared.

  Statistics based on (constructed from) external moments cannot be incremented or cleared.

Constructor Detail

### Kurtosis

    public Kurtosis()

  Construct a Kurtosis

### Kurtosis

    public Kurtosis(org.apache.commons.math3.stat.descriptive.moment.FourthMoment m4)

  Construct a Kurtosis from an external moment

  Parameters:
    `m4` - external Moment

### Kurtosis

    public Kurtosis(Kurtosis original)
             throws NullArgumentException

  Copy constructor, creates a new `Kurtosis` identical to the `original`

  Parameters:
    `original` - the `Kurtosis` instance to copy
  Throws:
    `NullArgumentException` - if original is null

Method Detail

### increment

    public void increment(double d)

  Updates the internal state of the statistic to reflect the addition of the new value.

  Note that when `Kurtosis(FourthMoment)` is used to create a Variance, this method does nothing. In that case, the FourthMoment should be incremented directly.

  Specified by:
    `increment` in interface `StorelessUnivariateStatistic`
  Specified by:
    `increment` in class `AbstractStorelessUnivariateStatistic`
  Parameters:
    `d` - the new value.

### getResult

    public double getResult()

  Returns the current value of the Statistic.

  Specified by:
    `getResult` in interface `StorelessUnivariateStatistic`
  Specified by:
    `getResult` in class `AbstractStorelessUnivariateStatistic`
  Returns:
    value of the statistic, `Double.NaN` if it has been cleared or just instantiated.

### clear

    public void clear()

  Clears the internal state of the Statistic

  Specified by:
    `clear` in interface `StorelessUnivariateStatistic`
  Specified by:
    `clear` in class `AbstractStorelessUnivariateStatistic`

### getN

    public long getN()

  Returns the number of values that have been added.

  Specified by:
    `getN` in interface `StorelessUnivariateStatistic`
  Returns:
    the number of values.

### evaluate

    public double evaluate(double[] values,
                           int begin,
                           int length)
                    throws MathIllegalArgumentException

  Returns the kurtosis of the entries in the specified portion of the input array.

  See `Kurtosis` for details on the computing algorithm.

  Throws `IllegalArgumentException` if the array is null.

  Specified by:
    `evaluate` in interface `UnivariateStatistic`
  Specified by:
    `evaluate` in interface `MathArrays.Function`
  Overrides:
    `evaluate` in class `AbstractStorelessUnivariateStatistic`
  Parameters:
    `values` - the input array
    `begin` - index of the first array element to include
    `length` - the number of elements to include
  Returns:
    the kurtosis of the values or Double.NaN if length is less than 4
  Throws:
    `MathIllegalArgumentException` - if the input array is null or the array index parameters are not valid
  See Also:
    `UnivariateStatistic.evaluate(double[], int, int)`

### copy

    public Kurtosis copy()

  Returns a copy of the statistic with the same internal state.

  Specified by:
    `copy` in interface `StorelessUnivariateStatistic`
  Specified by:
    `copy` in interface `UnivariateStatistic`
  Specified by:
    `copy` in class `AbstractStorelessUnivariateStatistic`
  Returns:
    a copy of the statistic

### copy

    public static void copy(Kurtosis source,
                            Kurtosis dest)
                     throws NullArgumentException

  Copies source to dest.

  Neither source nor dest can be null.

  Parameters:
    `source` - Kurtosis to copy
    `dest` - Kurtosis to copy to
  Throws:
    `NullArgumentException` - if either source or dest is null

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.